/*
Bubble sort
*/

#include <iostream>
using namespace std;


template <typename T>
void printarray(T arg[], int length)
{
    for(int n = 0; n < length; ++n)
        cout << arg[n] << ' ';

    cout << endl;
}


template <typename T>
int Input(T A[], int n)
{
    cout << "Enter array elements:";

    for(int i = 0; i < n; i++)
        cin >> A[i];

    return n;
}


template <typename T>
void BSort(T A[], int n)
{
    int I, J;

    for(I = 0; I < (n - 1); I++) //sorting
    {
        for(J = 0; J < (n - 1 - I); J++)
        {
            if(A[J] > A[J + 1])
            {
                swap(A[J], A[J + 1]);
            }
        }
    }
}

int main()
{
    int firstarray[7];
    Input(firstarray, 7);
    cout << "before sort: ";
    printarray(firstarray, 7);

    BSort(firstarray, 7);
    cout << "after sort: ";
    printarray(firstarray, 7);

    return 0;
}
