/*
Selection sort
*/

#include <iostream>
using namespace std;


template <typename T>
void printarray(T arg[], int length)
{
    for(int n = 0; n < length; ++n)
        cout << arg[n] << ' ';

    cout << endl;
}


template <typename T>
int Input(T A[], int n)
{
    cout << "Enter array elements:";

    for(int i = 0; i < n; i++)
        cin >> A[i];

    return n;
}


template <typename T>
void SSort(T A[], int n)
{
    int I, J, Small;

    for(I = 0; I < (n - 1); I++)
    {
        Small=I;

        for(J = I + 1; J < n; J++)
        {
            if(A[J] < A[Small])
                Small = J;
        }

        if(Small != I)
        {
            swap(A[I], A[Small]);
        }
    }
}

int main()
{
    int firstarray[7];
    Input(firstarray, 7);
    cout << "before sort: ";
    printarray(firstarray, 7);

    SSort(firstarray, 7);
    cout << "after sort: ";
    printarray(firstarray, 7);

    return 0;
}
