// H file we implemented in class (not optimized)
#include "heap.h"

int main()
{
    // randomly sorted array of ints:
    int C[] = {73, 6, 57, 88, 60, 34, 83, 72, 48, 85, 24, 52};

    cout << "Bag of of ints: " << endl;

    for(int i = 0; i < 12; i++ )
        cout << C[i] << " ";

    // Use heap to sort here!
    // (Constructor heapifies efficiently)
    heap<int> myheap(C, 12, 12);

    int sorted[12];

    for(int i = 0; i < 12; i++)
        sorted[i] = myheap.removefirst();

    cout << endl << endl << "Sorted array: " << endl;

    for(int i = 0; i < 12; i++ )
        cout << sorted[i] << " ";

    return 0;
}
